#include <iostream>
#include <string>

std::string rr (std::string radek);
int rn (std::string radek);
std::string rI (std::string radek);
std::string rD (std::string radek);
std::string rE (std::string radek);

int rL(std::string c);
int rP(std::string kde, std::string co);

std::string promene[26];
int i = 1;

std::string insert(std::string kam, int index, std::string co)
{
	if(index <= 0)
	{
		return co+kam;
	}
	if(index >= kam.length())
	{
		return kam+co;
	}
	return kam.substr(0, index)+co+kam.substr(index);

}

std::string smaz(std::string kde, int odkud, int kam)
{
	if(odkud > kam ) return kde;
	if(kam < 0 && odkud < 0) return kde;
	if(kam >= (int)kde.length() && odkud >= (int)kde.length()) return kde;
	if(odkud < 0) odkud = 0;
	if(kam >= (int)kde.length()) kam = (int)kde.length()-1;
	return kde.erase(odkud, kam-odkud+1);
}

std::string ext(std::string s, int start, int konec)
{
	if(start > konec) return "";
	if(konec < 0 && start < 0) return "";
	if(konec >= (int)s.length() && start >= (int)s.length()) return "";
	if(start < 0) start = 0;
	return s.substr(start, konec-start+1);
}

int rL(std::string c)
{
	return c.length();
}

int rP(std::string kde, std::string co)
{
	std::string::size_type l = kde.find(co);
	if(l != std::string::npos)
	{
		return l;
	}
	return -1;
}

std::string rI(std::string radek)
{
	++i;
	std::string s1 = rr(radek);
	++i;
	int in = rn(radek);
	++i;
	std::string s2 = rr(radek);
	++i;
	return insert(s1, in, s2);
}

std::string rD(std::string radek)
{
	++i;
	std::string s1 = rr(radek);
	++i;
	int od = rn(radek);
	++i;
	int doi = rn(radek);
	++i;
	return smaz(s1, od, doi);
}

std::string rE (std::string radek)
{
	++i;
	std::string s1 = rr(radek);
	++i;
	int od = rn(radek);
	++i;
	int doi = rn(radek);
	++i;
	return ext(s1, od, doi);
}

int rn(std::string radek)
{
	if((radek[i] >= '0' && radek[i] <='9') || radek[i] == '-')
	{
		int ret = 0;
		if(radek[i] == '-')
		{
			++i;
			ret = -(radek[i]-'0');
		}else
		{
		ret = radek[i]-'0';
		}
		++i;
		while(radek[i] >= '0' && radek[i] <='9')
		{
			ret = ret*10 + radek[i]-'0';
			++i;
		}
		return ret;
	}else
	{
		switch(radek[i])
		{
		case 'L':
			{
				i+=2;
				std::string s1 = rr(radek);
				++i;
				return rL(s1);
			}
		case 'P':
			{
				i+=2;
				std::string s1 = rr(radek);
				++i;
				std::string s2 = rr(radek);
				++i;
				return rP(s1, s2);
			}
		default:
			{
			return 0;
			}
		}
	}
}

std::string rr (std::string radek)
{
	if(radek[i] == '"')
	{
		++i;
		int s = i;
		int p = 0;
		while(radek[i] != '"') 
		{
			++i;
			++p;
		}
		++i;
		return radek.substr(s, p);
	}else
	{
		if(radek[i] >='a' && radek[i] <='z')
		{
			return promene[radek[i++]-'a'];
		}else
		{
			switch(radek[i])
			{
			case 'I':
			{
				++i;
				return rI(radek);
			}
			case 'D':
			{
				++i;
				return rD(radek);
			}
			case 'E':
			{
				++i;
				return rE(radek);
			}
			default:
			{
				++i;
				return"";
			}
			}
		}
	}
}



int main(int argc, char* argv[])
{
	
	std::string radek;
	int aktualI = 0;
	std::getline(std::cin, radek);
	while(!std::cin.eof() || radek != "")
	{
		aktualI = radek[0] - 'a';
		i = 1;
		while(radek[i] == '=') {i++;}
		if(radek[i] == '"')
		{
			// prirazeni retezce;
			promene[aktualI] = radek.substr(i+1, radek.length()-i-2);
		}else
		{
			// funkce
			promene[aktualI] = rr(radek);
		}
		radek = "";
		std::getline(std::cin, radek);
	}
	std::cout <<'"'<< promene[aktualI]<<'"'<<std::endl;
	std::cout.flush();
	return 0;
}